Index: trunk/LMDZ.COMMON/libf/evolution/pem.F90
===================================================================
--- trunk/LMDZ.COMMON/libf/evolution/pem.F90	(revision 3145)
+++ trunk/LMDZ.COMMON/libf/evolution/pem.F90	(revision 3149)
@@ -568,53 +550,30 @@
 !    I_g Save initial PCM situation
 !------------------------
-allocate(initial_co2_ice_sublim(ngrid,nslope))
-allocate(initial_co2_ice(ngrid,nslope))
-allocate(initial_h2o_ice(ngrid,nslope))
-
 ! We save the places where water ice is sublimating
 ! We compute the surface of water ice sublimating
-ini_surf_co2 = 0.
-ini_surf_h2o = 0.
+co2_surf_ini = 0.
+h2o_surf_ini = 0.
 Total_surface = 0.
 do i = 1,ngrid
     Total_surface = Total_surface + cell_area(i)
     do islope = 1,nslope
-        if (tendencies_co2_ice(i,islope) < 0) then
-            initial_co2_ice_sublim(i,islope) = 1.
-            ini_surf_co2 = ini_surf_co2 + cell_area(i)*subslope_dist(i,islope)
-        else
-            initial_co2_ice_sublim(i,islope) = 0.
-        endif
-        if (qsurf(i,igcm_co2,islope) > 0) then
-            initial_co2_ice(i,islope) = 1.
-        else
-            initial_co2_ice(i,islope) = 0.
-        endif
-        if (tendencies_h2o_ice(i,islope) < 0) then
-            initial_h2o_ice(i,islope) = 1.
-            ini_surf_h2o = ini_surf_h2o + cell_area(i)*subslope_dist(i,islope)
-        else
-            initial_h2o_ice(i,islope) = 0.
-        endif
+        if (tend_co2_ice(i,islope) < 0.) co2_surf_ini = co2_surf_ini + cell_area(i)*subslope_dist(i,islope)
+        if (tend_h2o_ice(i,islope) < 0.) h2o_surf_ini = h2o_surf_ini + cell_area(i)*subslope_dist(i,islope)
     enddo
 enddo
 
-write(*,*) "Total initial surface of co2 ice sublimating (slope) =", ini_surf_co2
-write(*,*) "Total initial surface of h2o ice sublimating (slope) =", ini_surf_h2o
+write(*,*) "Total initial surface of co2 ice sublimating (slope) =", co2_surf_ini
+write(*,*) "Total initial surface of h2o ice sublimating (slope) =", h2o_surf_ini
 write(*,*) "Total surface of the planet =", Total_surface
-allocate(zplev_gcm(ngrid,nlayer + 1))
+allocate(zplev_PCM(ngrid,nlayer + 1))
 
 do ig = 1,ngrid
-    zplev_gcm(ig,:) = ap(:) + bp(:)*ps_start_GCM(ig)
+    zplev_PCM(ig,:) = ap + bp*ps_start_PCM(ig)
 enddo
 
-global_ave_press_old = 0.
-do i = 1,ngrid
-    global_ave_press_old = global_ave_press_old + cell_area(i)*ps_start_GCM(i)/Total_surface
-enddo
-
-global_ave_press_GCM = global_ave_press_old
-global_ave_press_new = global_ave_press_old
-write(*,*) "Initial global average pressure =", global_ave_press_GCM
+global_avg_press_old = sum(cell_area*ps_start_PCM)/Total_surface
+global_avg_press_PCM = global_avg_press_old
+global_avg_press_new = global_avg_press_old
+write(*,*) "Initial global average pressure =", global_avg_press_PCM
 
 !------------------------
@@ -622,23 +581,17 @@
 !    I_h Read the startpem.nc
 !------------------------
+allocate(co2_ice(ngrid,nslope),h2o_ice(ngrid,nslope))
+deallocate(min_co2_ice,min_h2o_ice)
+
 call pemetat0("startpem.nc",ngrid,nsoilmx,nsoilmx_PEM,nslope,timelen,timestep,TI_PEM,tsoil_PEM,porefillingice_depth, &
-              porefillingice_thickness,tsurf_ave_yr1, tsurf_ave, q_co2_PEM_phys, q_h2o_PEM_phys,ps_timeseries,       &
-              tsoil_phys_PEM_timeseries,tendencies_h2o_ice,tendencies_co2_ice,qsurf(:,igcm_co2,:),                   &
-              qsurf(:,igcm_h2o_ice,:),global_ave_press_GCM,watersurf_density_ave,watersoil_density_PEM_ave,          &
-              co2_adsorbded_phys,delta_co2_adsorbded,h2o_adsorbded_phys,delta_h2o_adsorbded,water_reservoir)
-
-delta_h2o_icetablesublim(:) = 0.
-
-! We save the initial values for the co2 frost and perennial ice
-allocate(co2frost_ini(ngrid,nslope),perennial_co2ice_ini(ngrid,nslope))
-co2frost_ini = qsurf(:,igcm_co2,:)
-perennial_co2ice_ini = perennial_co2ice
-
-do ig = 1,ngrid
-    do islope = 1,nslope
-        qsurf(ig,igcm_h2o_ice,islope) = qsurf(ig,igcm_h2o_ice,islope) + water_reservoir(ig)*cos(pi*def_slope_mean(islope)/180.)
-        qsurf(ig,igcm_co2,islope) = qsurf(ig,igcm_co2,islope) + perennial_co2ice(ig,islope)
-    enddo
-enddo
+              porefillingice_thickness,tsurf_avg_yr1,tsurf_ave,q_co2_PEM_phys,q_h2o_PEM_phys,ps_timeseries,          &
+              tsoil_phys_PEM_timeseries,tend_h2o_ice,tend_co2_ice,co2_ice,h2o_ice,global_avg_press_PCM,              &
+              watersurf_density_ave,watersoil_density_PEM_ave,co2_adsorbded_phys,delta_co2_adsorbded,                &
+              h2o_adsorbded_phys,delta_h2o_adsorbded)
+
+allocate(co2_ice_ini(ngrid,nslope))
+co2_ice_ini = co2_ice
+
+delta_h2o_icetablesublim = 0.
 
 if (adsorption_pem) then
@@ -648,16 +601,15 @@
         do islope = 1,nslope
             do l = 1,nsoilmx_PEM - 1
-                totmassco2_adsorbded = totmassco2_adsorbded + co2_adsorbded_phys(ig,l,islope)*(layer_PEM(l+1) - layer_PEM(l))* &
+                totmassco2_adsorbded = totmassco2_adsorbded + co2_adsorbded_phys(ig,l,islope)*(layer_PEM(l + 1) - layer_PEM(l))* &
                                        subslope_dist(ig,islope)/cos(pi*def_slope_mean(islope)/180.)*cell_area(ig)
-                totmassh2o_adsorbded = totmassh2o_adsorbded + h2o_adsorbded_phys(ig,l,islope)*(layer_PEM(l+1) - layer_PEM(l))* &
+                totmassh2o_adsorbded = totmassh2o_adsorbded + h2o_adsorbded_phys(ig,l,islope)*(layer_PEM(l + 1) - layer_PEM(l))* &
                                        subslope_dist(ig,islope)/cos(pi*def_slope_mean(islope)/180.)*cell_area(ig)
             enddo
         enddo
     enddo
-
     write(*,*) "Tot mass of CO2 in the regolith =", totmassco2_adsorbded
     write(*,*) "Tot mass of H2O in the regolith =", totmassh2o_adsorbded
 endif ! adsorption
-deallocate(tsurf_ave_yr1)
+deallocate(tsurf_avg_yr1)
 
 !------------------------
@@ -684,4 +636,5 @@
 !------------------------
 year_iter = 0
+stopPEM = 0
 
 do while (year_iter < year_iter_max .and. i_myear < n_myear)
@@ -690,5 +643,5 @@
     do i = 1,ngrid
         do islope = 1,nslope
-            global_ave_press_new = global_ave_press_new - g*cell_area(i)*tendencies_co2_ice(i,islope)*subslope_dist(i,islope)/cos(pi*def_slope_mean(islope)/180.)/Total_surface
+            global_avg_press_new = global_avg_press_new - g*cell_area(i)*tend_co2_ice(i,islope)*subslope_dist(i,islope)/cos(pi*def_slope_mean(islope)/180.)/Total_surface
         enddo
     enddo
@@ -696,9 +649,9 @@
     if (adsorption_pem) then
         do i = 1,ngrid
-            global_ave_press_new = global_ave_press_new - g*cell_area(i)*delta_co2_adsorbded(i)/Total_surface
+            global_avg_press_new = global_avg_press_new - g*cell_area(i)*delta_co2_adsorbded(i)/Total_surface
         enddo
     endif
-    write(*,*) 'Global average pressure old time step',global_ave_press_old
-    write(*,*) 'Global average pressure new time step',global_ave_press_new
+    write(*,*) 'Global average pressure old time step',global_avg_press_old
+    write(*,*) 'Global average pressure new time step',global_avg_press_new
 
 ! II.a.2. Old pressure levels for the timeseries, this value is deleted when unused and recreated each time (big memory consuption)
@@ -714,9 +667,9 @@
     write(*,*) "Recomputing the surface pressure timeserie adapted to the new pressure..."
     do ig = 1,ngrid
-        ps_timeseries(ig,:) = ps_timeseries(ig,:)*global_ave_press_new/global_ave_press_old
+        ps_timeseries(ig,:) = ps_timeseries(ig,:)*global_avg_press_new/global_avg_press_old
     enddo
 
 ! II.a.4. New pressure levels timeseries
-    allocate(zplev_new_timeseries(ngrid,nlayer+1,timelen))
+    allocate(zplev_new_timeseries(ngrid,nlayer + 1,timelen))
     write(*,*) "Recomputing the new pressure levels timeserie adapted to the new pressure..."
     do l = 1,nlayer + 1
@@ -755,5 +708,5 @@
             endif
             mmean=1/(A*q_co2_PEM_phys(ig,t) + B)
-            vmr_co2_pem_phys(ig,t) = q_co2_PEM_phys(ig,t)*mmean/m_co2
+            vmr_co2_PEM_phys(ig,t) = q_co2_PEM_phys(ig,t)*mmean/m_co2
         enddo
     enddo
@@ -763,22 +716,16 @@
 !------------------------
 ! II  Run
-!    II_b Evolution of the ice
-!------------------------
-    write(*,*) "Evolution of h2o ice"
-    call evol_h2o_ice_s(ngrid,nslope,cell_area,delta_h2o_adsorbded,delta_h2o_icetablesublim,qsurf(:,igcm_h2o_ice,:),tendencies_h2o_ice,STOPPING_1_water)
-
-    write(*,*) "Evolution of co2 ice"
-    call evol_co2_ice_s(qsurf(:,igcm_co2,:),tendencies_co2_ice,iim,jjm_value,ngrid,cell_area,nslope)
+!    II_b Evolution of ice
+!------------------------
+    call evol_h2o_ice(ngrid,nslope,cell_area,delta_h2o_adsorbded,delta_h2o_icetablesublim,h2o_ice,tend_h2o_ice,stopPEM)
+    call evol_co2_ice(ngrid,nslope,co2_ice,tend_co2_ice)
 
 !------------------------
 ! II  Run
-!    II_c CO2 & H2O glaciers flows
-!------------------------
-    write(*,*) "CO2 glacier flows"
-    if (co2glaciersflow) call co2glaciers_evol(timelen,ngrid,nslope,iflat,subslope_dist,def_slope_mean,vmr_co2_pem_phys,ps_timeseries, &
-                                               global_ave_press_GCM,global_ave_press_new,qsurf(:,igcm_co2,:),flag_co2flow,flag_co2flow_mesh)
-
-    write(*,*) "H2O glacier flows"
-    if (h2oglaciersflow) call h2oglaciers_evol(timelen,ngrid,nslope,iflat,subslope_dist,def_slope_mean,tsurf_ave,qsurf(:,igcm_h2o_ice,:),flag_h2oflow,flag_h2oflow_mesh)
+!    II_c Flow of glaciers
+!------------------------
+    if (co2_ice_flow) call flow_co2glaciers(timelen,ngrid,nslope,iflat,subslope_dist,def_slope_mean,vmr_co2_PEM_phys,ps_timeseries, &
+                                            global_avg_press_PCM,global_avg_press_new,co2_ice,flag_co2flow,flag_co2flow_mesh)
+    if (h2o_ice_flow) call flow_h2oglaciers(timelen,ngrid,nslope,iflat,subslope_dist,def_slope_mean,tsurf_ave,h2o_ice,flag_h2oflow,flag_h2oflow_mesh)
 
 !------------------------
@@ -789,12 +736,12 @@
     write(*,*) "Updating the new Tsurf"
     bool_sublim = .false.
-    Tsurfave_before_saved(:,:) = tsurf_ave(:,:)
+    Tsurfavg_before_saved = tsurf_ave
     do ig = 1,ngrid
         do islope = 1,nslope
-            if (initial_co2_ice(ig,islope) > 0.5 .and. qsurf(ig,igcm_co2,islope) < 1.e-10) then !co2ice disappeared, look for closest point without co2ice
+            if (co2_ice_ini(ig,islope) > 0.5 .and. co2_ice(ig,islope) < 1.e-10) then ! co2 ice disappeared, look for closest point without co2ice
                 if (latitude_deg(ig) > 0) then
                     do ig_loop = ig,ngrid
                         do islope_loop = islope,iflat,-1
-                            if (initial_co2_ice(ig_loop,islope_loop) < 0.5 .and. qsurf(ig_loop,igcm_co2,islope_loop) < 1.e-10) then
+                            if (co2_ice_ini(ig_loop,islope_loop) < 0.5 .and. co2_ice(ig_loop,islope_loop) < 1.e-10) then
                                 tsurf_ave(ig,islope) = tsurf_ave(ig_loop,islope_loop)
                                 bool_sublim = .true.
@@ -807,5 +754,5 @@
                     do ig_loop = ig,1,-1
                         do islope_loop = islope,iflat
-                            if(initial_co2_ice(ig_loop,islope_loop) < 0.5 .and. qsurf(ig_loop,igcm_co2,islope_loop) < 1.e-10) then
+                            if(co2_ice_ini(ig_loop,islope_loop) < 0.5 .and. co2_ice(ig_loop,islope_loop) < 1.e-10) then
                                 tsurf_ave(ig,islope) = tsurf_ave(ig_loop,islope_loop)
                                 bool_sublim = .true.
@@ -816,6 +763,6 @@
                     enddo
                 endif
-                initial_co2_ice(ig,islope) = 0
-                if ((qsurf(ig,igcm_co2,islope) < 1.e-10) .and. (qsurf(ig,igcm_h2o_ice,islope) > frost_albedo_threshold)) then
+                co2_ice_ini(ig,islope) = 0
+                if ((co2_ice(ig,islope) < 1.e-10) .and. (h2o_ice(ig,islope) > frost_albedo_threshold)) then
                     albedo(ig,1,islope) = albedo_h2o_frost
                     albedo(ig,2,islope) = albedo_h2o_frost
@@ -825,11 +772,11 @@
                     emis(ig,islope) = emissiv
                 endif
-            else if ((qsurf(ig,igcm_co2,islope) > 1.e-3) .and. (tendencies_co2_ice(ig,islope) > 1.e-10)) then !Put tsurf as tcond co2
+            else if ((co2_ice(ig,islope) > 1.e-3) .and. (tend_co2_ice(ig,islope) > 1.e-10)) then ! Put tsurf as tcond co2
                 ave = 0.
                 do t = 1,timelen
-                    if (co2_ice_GCM(ig,islope,t) > 1.e-3) then
-                        ave = ave + beta_clap_co2/(alpha_clap_co2-log(vmr_co2_pem_phys(ig,t)*ps_timeseries(ig,t)/100.))
+                    if (co2_ice_PCM(ig,islope,t) > 1.e-3) then
+                        ave = ave + beta_clap_co2/(alpha_clap_co2-log(vmr_co2_PEM_phys(ig,t)*ps_timeseries(ig,t)/100.))
                     else
-                        ave = ave + tsurf_GCM_timeseries(ig,islope,t)
+                        ave = ave + tsurf_PCM_timeseries(ig,islope,t)
                     endif
                 enddo
@@ -849,10 +796,10 @@
 
     do t = 1,timelen
-        tsurf_GCM_timeseries(:,:,t) = tsurf_GCM_timeseries(:,:,t) + (tsurf_ave(:,:) - Tsurfave_before_saved(:,:))
+        tsurf_PCM_timeseries(:,:,t) = tsurf_PCM_timeseries(:,:,t) + tsurf_ave - Tsurfavg_before_saved
     enddo
     ! for the start
     do ig = 1,ngrid
         do islope = 1,nslope
-            tsurf(ig,islope) =  tsurf(ig,islope) - (Tsurfave_before_saved(ig,islope) - tsurf_ave(ig,islope))
+            tsurf(ig,islope) =  tsurf(ig,islope) - (Tsurfavg_before_saved(ig,islope) - tsurf_ave(ig,islope))
         enddo
     enddo
@@ -868,11 +815,11 @@
         ! Soil averaged
         do islope = 1,nslope
-            TI_locslope(:,:) = TI_PEM(:,:,islope)
+            TI_locslope = TI_PEM(:,:,islope)
             do t = 1,timelen
-                Tsoil_locslope(:,:) = tsoil_phys_PEM_timeseries(:,:,islope,t)
-                Tsurf_locslope(:) = tsurf_GCM_timeseries(:,islope,t)
+                Tsoil_locslope = tsoil_phys_PEM_timeseries(:,:,islope,t)
+                Tsurf_locslope = tsurf_PCM_timeseries(:,islope,t)
                 call soil_pem_compute(ngrid,nsoilmx_PEM,.true.,TI_locslope,timestep/timelen,Tsurf_locslope,Tsoil_locslope)
                 call soil_pem_compute(ngrid,nsoilmx_PEM,.false.,TI_locslope,timestep/timelen,Tsurf_locslope,Tsoil_locslope)
-                tsoil_phys_PEM_timeseries(:,:,islope,t) = Tsoil_locslope(:,:)
+                tsoil_phys_PEM_timeseries(:,:,islope,t) = Tsoil_locslope
                 do ig = 1,ngrid
                     do isoil = 1,nsoilmx_PEM
@@ -883,6 +830,6 @@
             enddo
         enddo
-        tsoil_PEM(:,:,:) = sum(tsoil_phys_PEM_timeseries(:,:,:,:),4)/timelen
-        watersoil_density_PEM_ave(:,:,:) = sum(watersoil_density_PEM_timeseries(:,:,:,:),4)/timelen
+        tsoil_PEM = sum(tsoil_phys_PEM_timeseries,4)/timelen
+        watersoil_density_PEM_ave = sum(watersoil_density_PEM_timeseries,4)/timelen
 
         write(*,*) "Update of soil temperature done"
@@ -892,17 +839,16 @@
 ! II_d.3 Update the ice table
         write(*,*) "Compute ice table"
-        porefillingice_thickness_prev_iter(:,:) = porefillingice_thickness(:,:)
+        porefillingice_thickness_prev_iter = porefillingice_thickness
         call computeice_table_equilibrium(ngrid,nslope,nsoilmx_PEM,watercaptag,watersurf_density_ave,watersoil_density_PEM_ave,TI_PEM(:,1,:),porefillingice_depth,porefillingice_thickness)
         call compute_massh2o_exchange_ssi(ngrid,nslope,nsoilmx_PEM,porefillingice_thickness_prev_iter,porefillingice_thickness,porefillingice_depth,tsoil_PEM,delta_h2o_icetablesublim) ! Mass of H2O exchange between the ssi and the atmosphere
 
 ! II_d.4 Update the soil thermal properties
-        write(*,*) "Update soil propreties"
-        call update_soil_thermalproperties(ngrid,nslope,nsoilmx_PEM,tendencies_h2o_ice,qsurf(:,igcm_h2o_ice,:),global_ave_press_new,porefillingice_depth,porefillingice_thickness,TI_PEM)
+        call update_soil_thermalproperties(ngrid,nslope,nsoilmx_PEM,tend_h2o_ice,h2o_ice,global_avg_press_new,porefillingice_depth,porefillingice_thickness,TI_PEM)
 
 ! II_d.5 Update the mass of the regolith adsorbed
         if (adsorption_pem) then
-            call regolith_adsorption(ngrid,nslope,nsoilmx_PEM,timelen,tendencies_h2o_ice,tendencies_co2_ice, &
-                                     qsurf(:,igcm_h2o_ice,:),qsurf(:,igcm_co2,:),tsoil_PEM,TI_PEM,ps_timeseries, &
-                                     q_co2_PEM_phys,q_h2o_PEM_phys,h2o_adsorbded_phys,delta_h2o_adsorbded,co2_adsorbded_phys,delta_co2_adsorbded)
+            call regolith_adsorption(ngrid,nslope,nsoilmx_PEM,timelen,tend_h2o_ice,tend_co2_ice,       &
+                                     h2o_ice,co2_ice,tsoil_PEM,TI_PEM,ps_timeseries,q_co2_PEM_phys,q_h2o_PEM_phys, &
+                                     h2o_adsorbded_phys,delta_h2o_adsorbded,co2_adsorbded_phys,delta_co2_adsorbded)
 
             totmassco2_adsorbded = 0.
@@ -911,7 +857,7 @@
                 do islope =1, nslope
                     do l = 1,nsoilmx_PEM - 1
-                        totmassco2_adsorbded = totmassco2_adsorbded + co2_adsorbded_phys(ig,l,islope)*(layer_PEM(l+1) - layer_PEM(l))* &
+                        totmassco2_adsorbded = totmassco2_adsorbded + co2_adsorbded_phys(ig,l,islope)*(layer_PEM(l + 1) - layer_PEM(l))* &
                         subslope_dist(ig,islope)/cos(pi*def_slope_mean(islope)/180.)*cell_area(ig)
-                        totmassh2o_adsorbded = totmassh2o_adsorbded + h2o_adsorbded_phys(ig,l,islope)*(layer_PEM(l+1) - layer_PEM(l))* &
+                        totmassh2o_adsorbded = totmassh2o_adsorbded + h2o_adsorbded_phys(ig,l,islope)*(layer_PEM(l + 1) - layer_PEM(l))* &
                         subslope_dist(ig,islope)/cos(pi*def_slope_mean(islope)/180.)*cell_area(ig)
                     enddo
@@ -927,11 +873,11 @@
 !    II_e Outputs
 !------------------------
-    call writediagpem(ngrid,'ps_ave','Global average pressure','Pa',0,(/global_ave_press_new/))
+    call writediagpem(ngrid,'ps_ave','Global average pressure','Pa',0,(/global_avg_press_new/))
     do islope = 1,nslope
         write(str2(1:2),'(i2.2)') islope
-        call writediagpem(ngrid,'h2o_ice_s_slope'//str2,'H2O ice','kg.m-2',2,qsurf(:,igcm_h2o_ice,islope))
-        call writediagpem(ngrid,'tendencies_h2o_ice_slope'//str2,'H2O ice tend','kg.m-2.year-1',2,tendencies_h2o_ice(:,islope))
-        call writediagpem(ngrid,'tendencies_co2_ice_slope'//str2,'CO2 ice tend','kg.m-2.year-1',2,tendencies_co2_ice(:,islope))
-        call writediagpem(ngrid,'co2ice_slope'//str2,'CO2 ice','kg.m-2',2,qsurf(:,igcm_co2,islope))
+        call writediagpem(ngrid,'h2o_ice_slope'//str2,'H2O ice','kg.m-2',2,h2o_ice(:,islope))
+        call writediagpem(ngrid,'co2_ice_slope'//str2,'CO2 ice','kg.m-2',2,co2_ice(:,islope))
+        call writediagpem(ngrid,'tend_h2o_ice_slope'//str2,'H2O ice tend','kg.m-2.year-1',2,tend_h2o_ice(:,islope))
+        call writediagpem(ngrid,'tend_co2_ice_slope'//str2,'CO2 ice tend','kg.m-2.year-1',2,tend_co2_ice(:,islope))
         call writediagpem(ngrid,'Flow_co2ice_slope'//str2,'CO2 ice flow','Boolean',2,flag_co2flow(:,islope))
         call writediagpem(ngrid,'tsurf_slope'//str2,'tsurf','K',2,tsurf(:,islope))
@@ -942,7 +888,6 @@
 !    II_f Update the tendencies
 !------------------------
-    write(*,*) "Adaptation of the new co2 tendencies to the current pressure"
-    call recomp_tend_co2_slope(ngrid,nslope,timelen,tendencies_co2_ice,tendencies_co2_ice_ini,qsurf(:,igcm_co2,:),emis,vmr_co2_gcm,vmr_co2_pem_phys,ps_timeseries, &
-                               global_ave_press_GCM,global_ave_press_new)
+    call recomp_tend_co2_slope(ngrid,nslope,timelen,tend_co2_ice,tend_co2_ice_ini,co2_ice,emis,vmr_co2_PCM,vmr_co2_PEM_phys,ps_timeseries, &
+                               global_avg_press_PCM,global_avg_press_new)
 
 !------------------------
@@ -950,39 +895,30 @@
 !    II_g Checking the stopping criterion
 !------------------------
-    call criterion_waterice_stop(cell_area,ini_surf_h2o,qsurf(:,igcm_h2o_ice,:),STOPPING_water,ngrid,initial_h2o_ice)
-
-    call criterion_co2_stop(cell_area,ini_surf_co2,qsurf(:,igcm_co2,:),STOPPING_co2,STOPPING_pressure,ngrid, &
-                            initial_co2_ice_sublim,global_ave_press_GCM,global_ave_press_new,nslope)
+    call stopping_crit_h2o_ice(cell_area,h2o_surf_ini,h2o_ice,stopPEM,ngrid)
+    call stopping_crit_co2(cell_area,co2_surf_ini,co2_ice,stopPEM,ngrid,global_avg_press_PCM,global_avg_press_new,nslope)
 
     year_iter = year_iter + dt_pem
     i_myear = i_myear + dt_pem
 
-    write(*,*) "Checking all the stopping criteria..."
-    if (STOPPING_water) then
-        write(*,*) "STOPPING because surface of water ice sublimating is too low, see message above", STOPPING_water
-        criterion_stop = 1
-    endif
-    if (STOPPING_1_water) then
-        write(*,*) "STOPPING because tendencies on water ice=0, see message above", STOPPING_1_water
-        criterion_stop = 1
-    endif
-    if (STOPPING_co2) then
-        write(*,*) "STOPPING because surface of co2 ice sublimating is too low, see message above", STOPPING_co2
-        criterion_stop = 2
-    endif
-    if (STOPPING_pressure) then
-        write(*,*) "STOPPING because surface global pressure changed too much, see message above", STOPPING_pressure
-        criterion_stop = 3
-    endif
-    if (year_iter >= year_iter_max) then
-        write(*,*) "STOPPING because maximum number of iterations reached"
-        criterion_stop = 4
-    endif
-    if (i_myear >= n_myear) then
-        write(*,*) "STOPPING because maximum number of Martian years to be simulated reached"
-        criterion_stop = 5
-    endif
-
-    if (STOPPING_water .or. STOPPING_1_water .or. STOPPING_co2 .or. STOPPING_pressure)  then
+    write(*,*) "Checking the stopping criteria..."
+    if (year_iter >= year_iter_max) stopPEM = 5
+    if (i_myear >= n_myear) stopPEM = 6
+    if (stopPEM > 0) then
+        select case (stopPEM)
+            case(1)
+                write(*,*) "STOPPING because surface of water ice sublimating is too low:", stopPEM, "See message above."
+            case(2)
+                write(*,*) "STOPPING because tendencies on water ice = 0:", stopPEM, "See message above."
+            case(3)
+                write(*,*) "STOPPING because surface of co2 ice sublimating is too low:", stopPEM, "See message above."
+            case(4)
+                write(*,*) "STOPPING because surface global pressure changed too much:", stopPEM, "See message above."
+            case(5)
+                write(*,*) "STOPPING because maximum number of iterations due to orbital parameters is reached:", stopPEM
+            case(6)
+                write(*,*) "STOPPING because maximum number of Martian years to be simulated is reached:", stopPEM
+            case default
+                write(*,*) "STOPPING with unknown stopping criterion code:", stopPEM
+        end select
         exit
     else
@@ -992,7 +928,7 @@
     endif
 
-    global_ave_press_old = global_ave_press_new
-
-enddo  ! big time iteration loop of the pem
+    global_avg_press_old = global_avg_press_new
+
+enddo ! big time iteration loop of the pem
 !------------------------------ END RUN --------------------------------
 
@@ -1005,84 +941,27 @@
 
 ! H2O ice
+watercap = 0.
 do ig = 1,ngrid
-    if (watercaptag(ig)) then
-        watercap_sum = 0.
-        do islope = 1,nslope
-            ! water_reservoir and watercap have not changed since PCM call: here we check if we have accumulate frost or not.
-            if (qsurf(ig,igcm_h2o_ice,islope) > water_reservoir(ig)*cos(pi*def_slope_mean(islope)/180.)) then
-                ! 1st case: more ice than initialy. Put back ancien frost
-                qsurf(ig,igcm_h2o_ice,islope) = qsurf(ig,igcm_h2o_ice,islope) - water_reservoir(ig)*cos(pi*def_slope_mean(islope)/180.)
-            else
-                ! 2nd case: ice sublimated. Then let's put qsurf = 0 and add the difference in watercap
-                watercap(ig,islope) = qsurf(ig,igcm_h2o_ice,islope)
-                qsurf(ig,igcm_h2o_ice,islope) = 0.
-            endif
-            watercap_sum = watercap_sum + watercap(ig,islope)*subslope_dist(ig,islope)/cos(pi*def_slope_mean(islope)/180.)
-            watercap(ig,islope) = 0.
-        enddo
-        water_reservoir(ig) = water_reservoir(ig) + watercap_sum
+    if (sum(h2o_ice(ig,:)*subslope_dist(ig,:)/cos(pi*def_slope_mean(:)/180.)) > inf_h2oice_threshold) then
+    ! If there is enough ice to be considered as an infinite reservoir
+        watercaptag(ig) = .true.
+    else
+    ! If there too little ice to be considered as an infinite reservoir
+    ! Ice is transferred to the frost
+        watercaptag(ig) = .false.
+        qsurf(ig,igcm_h2o_ice,:) = qsurf(ig,igcm_h2o_ice,:) + h2o_ice(ig,:)
+        h2o_ice(ig,:) = 0.
     endif
 enddo
 
-do ig = 1,ngrid
-    water_sum = 0.
-    do islope = 1,nslope
-        water_sum = water_sum + qsurf(ig,igcm_h2o_ice,islope)*subslope_dist(ig,islope)/cos(pi*def_slope_mean(islope)/180.)
-    enddo
-    if (.not. watercaptag(ig)) then ! let's check if we have an 'infinite' source of water that has been forming.
-        if (water_sum > threshold_h2o_frost2perennial) then ! the overall mesh can be considered as an infite source of water. No need to change the albedo: done in II.d.1
-            watercaptag(ig) = .true.
-            water_reservoir(ig) = water_reservoir(ig) + threshold_h2o_frost2perennial/2. ! half of the excess ices goes to the reservoir, we let the rest to be frost
-            do islope = 1,nslope
-                qsurf(ig,igcm_h2o_ice,islope) = qsurf(ig,igcm_h2o_ice,islope) - threshold_h2o_frost2perennial/2.*cos(pi*def_slope_mean(islope)/180.)
-            enddo
-        endif
-    else ! let's check that the infinite source of water disapear
-        if ((water_sum + water_reservoir(ig)) < threshold_h2o_frost2perennial) then
-            watercaptag(ig) = .false.
-            do islope = 1,nslope
-                qsurf(ig,igcm_h2o_ice,islope) = qsurf(ig,igcm_h2o_ice,islope) + water_reservoir(ig)*cos(pi*def_slope_mean(islope)/180.)
-            enddo
-            water_reservoir(ig) = 0.
-        endif
-    endif
-enddo
-
-! CO2 ice
-do ig = 1,ngrid
-    do islope = 1,nslope
-        if (qsurf(ig,igcm_co2,islope) == threshold_co2_frost2perennial) then
-        ! If co2 ice is equal to the threshold, then everything is transformed into perennial ice
-            perennial_co2ice(ig,islope) = threshold_co2_frost2perennial
-            qsurf(ig,igcm_co2,islope) = 0.
-        else if (qsurf(ig,igcm_co2,islope) > threshold_co2_frost2perennial) then
-        ! If co2 ice is superior to the threshold, then co2 frost is equal to the threshold (max possible value)
-        ! and the leftover is transformed into perennial ice
-            perennial_co2ice(ig,islope) = qsurf(ig,igcm_co2,islope) - threshold_co2_frost2perennial
-            qsurf(ig,igcm_co2,islope) = threshold_co2_frost2perennial
-        else
-        ! If co2 ice is inferior to the threshold, then we compare with the initial state
-            if (qsurf(ig,igcm_co2,islope) > perennial_co2ice_ini(ig,islope)) then
-            ! If co2 ice higher than the initial perennial ice, then the change is affected only to the frost
-                perennial_co2ice(ig,islope) = perennial_co2ice_ini(ig,islope)
-                qsurf(ig,igcm_co2,islope) = qsurf(ig,igcm_co2,islope) - perennial_co2ice_ini(ig,islope)
-            else
-            ! If co2 ice is lower than the initial perennial ice, then there is no frost anymore
-                perennial_co2ice(ig,islope) = qsurf(ig,igcm_co2,islope)
-                qsurf(ig,igcm_co2,islope) = 0.
-            endif
-        endif
-    enddo
-enddo
-
 ! III_a.2  Tsoil update (for startfi)
 if (soil_pem) then
-    call interpolate_TIPEM_TIGCM(ngrid,nslope,nsoilmx_PEM,nsoilmx,TI_PEM,inertiesoil)
-    tsoil(:,:,:) = tsoil_phys_PEM_timeseries(:,1:nsoilmx,:,timelen)
+    call interpol_TI_PEM2PCM(ngrid,nslope,nsoilmx_PEM,nsoilmx,TI_PEM,inertiesoil)
+    tsoil = tsoil_phys_PEM_timeseries(:,1:nsoilmx,:,timelen)
 endif
 
 ! III_a.4 Pressure (for start)
-ps(:) = ps(:)*global_ave_press_new/global_ave_press_GCM
-ps_start_GCM(:) = ps_start_GCM(:)*global_ave_press_new/global_ave_press_GCM
+ps = ps*global_avg_press_new/global_avg_press_PCM
+ps_start_PCM = ps_start_PCM*global_avg_press_new/global_avg_press_PCM
 
 ! III_a.5 Tracer (for start)
@@ -1090,5 +969,5 @@
 
 do l = 1,nlayer + 1
-    zplev_new(:,l) = ap(l) + bp(l)*ps_start_GCM(:)
+    zplev_new(:,l) = ap(l) + bp(l)*ps_start_PCM
 enddo
 
@@ -1097,5 +976,5 @@
         do l = 1,llm - 1
             do ig = 1,ngrid
-                q(ig,l,nnq) = q(ig,l,nnq)*(zplev_gcm(ig,l) - zplev_gcm(ig,l + 1))/(zplev_new(ig,l) - zplev_new(ig,l + 1))
+                q(ig,l,nnq) = q(ig,l,nnq)*(zplev_PCM(ig,l) - zplev_PCM(ig,l + 1))/(zplev_new(ig,l) - zplev_new(ig,l + 1))
             enddo
             q(:,llm,nnq) = q(:,llm - 1,nnq)
@@ -1104,6 +983,6 @@
         do l = 1,llm - 1
             do ig = 1,ngrid
-                q(ig,l,nnq) = q(ig,l,nnq)*(zplev_gcm(ig,l) - zplev_gcm(ig,l + 1))/(zplev_new(ig,l) - zplev_new(ig,l + 1)) &
-                              + ((zplev_new(ig,l) - zplev_new(ig,l + 1)) - (zplev_gcm(ig,l) - zplev_gcm(ig,l + 1)))/(zplev_new(ig,l) - zplev_new(ig,l + 1))
+                q(ig,l,nnq) = q(ig,l,nnq)*(zplev_PCM(ig,l) - zplev_PCM(ig,l + 1))/(zplev_new(ig,l) - zplev_new(ig,l + 1)) &
+                              + ((zplev_new(ig,l) - zplev_new(ig,l + 1)) - (zplev_PCM(ig,l) - zplev_PCM(ig,l + 1)))/(zplev_new(ig,l) - zplev_new(ig,l + 1))
             enddo
             q(:,llm,nnq) = q(:,llm - 1,nnq)
@@ -1178,7 +1057,8 @@
 call pemdem1("restartpem.nc",i_myear,nsoilmx_PEM,ngrid,nslope,tsoil_PEM, &
              TI_PEM, porefillingice_depth,porefillingice_thickness,      &
-             co2_adsorbded_phys,h2o_adsorbded_phys,water_reservoir)
+             co2_adsorbded_phys,h2o_adsorbded_phys,h2o_ice)
 write(*,*) "restartpem.nc has been written"
-call info_PEM(year_iter,criterion_stop,i_myear,n_myear)
+
+call info_PEM(year_iter,stopPEM,i_myear,n_myear)
 
 write(*,*) "The PEM has run for", year_iter, "Martian years."
@@ -1187,9 +1067,9 @@
 write(*,*) "LL & RV & JBC: so far, so good!"
 
-deallocate(vmr_co2_gcm,ps_timeseries,tsurf_GCM_timeseries,q_co2_PEM_phys,q_h2o_PEM_phys)
-deallocate(co2_ice_GCM,watersurf_density_ave,watersoil_density_timeseries,Tsurfave_before_saved)
+deallocate(vmr_co2_PCM,ps_timeseries,tsurf_PCM_timeseries,q_co2_PEM_phys,q_h2o_PEM_phys)
+deallocate(co2_ice_PCM,watersurf_density_ave,watersoil_density_timeseries,Tsurfavg_before_saved)
 deallocate(tsoil_phys_PEM_timeseries,watersoil_density_PEM_timeseries,watersoil_density_PEM_ave)
-deallocate(delta_co2_adsorbded,delta_h2o_adsorbded,vmr_co2_pem_phys,delta_h2o_icetablesublim,porefillingice_thickness_prev_iter)
-deallocate(co2frost_ini,perennial_co2ice_ini)
+deallocate(delta_co2_adsorbded,delta_h2o_adsorbded,vmr_co2_PEM_phys,delta_h2o_icetablesublim,porefillingice_thickness_prev_iter)
+deallocate(co2_ice_ini)
 !----------------------------- END OUTPUT ------------------------------
 
